/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 * Copyright (c) 1986 - 1991 by Sun Microsystems, Inc.
 */

#ifndef _RPC_SVCAUTH_H
#define	_RPC_SVCAUTH_H

#pragma ident	"@(#)svc_auth.h	1.10	93/07/05 SMI"

/*	 svc_auth.h 1.10 88/10/25 SMI	*/

/*
 * svc_auth.h, Service side of rpc authentication.
 */

#include <rpc/svc.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Server side authenticator
 */
#ifdef __STDC__
extern enum auth_stat __authenticate (struct svc_req *, struct rpc_msg *);
#ifdef __RPCLIB_INTERNAL__
extern enum auth_stat __svcauth_des (struct svc_req *, struct rpc_msg *);
extern enum auth_stat __svcauth_sys (struct svc_req *, struct rpc_msg *);
extern enum auth_stat __svcauth_short (struct svc_req *, struct rpc_msg *);
extern enum auth_stat __svcauth_unix(struct svc_req *, struct rpc_msg *);
extern enum auth_stat __svcauth_short(struct svc_req *, struct rpc_msg *);
extern enum auth_stat __svcauth_des(struct svc_req *, struct rpc_msg *);
extern enum auth_stat __svcauth_null(struct svc_req *, struct rpc_msg *);
int svc_auth_reg(int flavor, enum auth_stat (*handler)(struct svc_req *, struct rpc_msg *));

int __rpc_get_local_uid(SVCXPRT *trans, uid_t *uid_out);
int __rpc_negotiate_uid(int);

#endif
#else
extern enum auth_stat __authenticate ();
#endif

#ifdef __cplusplus
}
#endif

#endif	/* _RPC_SVCAUTH_H */
