/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 * Copyright (c) 1986 - 1991 by Sun Microsystems, Inc.
 */

/*
 * svc.h, Server-side remote procedure call interface.
 */

#ifndef _RPC_SVC_SOC_H
#define	_RPC_SVC_SOC_H

#pragma ident	"@(#)svc_soc.h	1.11	94/04/25 SMI"
/*	svc_soc.h 1.8 89/05/01 SMI	*/

/*
 * All the following declarations are only for backward compatibility
 * with SUNOS 4.0.
 */

#ifndef _KERNEL
#include <sys/socket.h>
#include <netinet/in.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  Approved way of getting address of caller
 */
#define	svc_getcaller(x) ((struct sockaddr_in *)(x)->xp_rtaddr.buf)
#define	svc_getspecdst(x) ((struct sockaddr_in *)(x)->xp_ltaddr.buf)
#endif	/* _KERNEL */

/*
 * Service registration
 *
 * svc_register(xprt, prog, vers, dispatch, protocol)
 *	SVCXPRT *xprt;
 *	u_long prog;
 *	u_long vers;
 *	void (*dispatch)();
 *	int protocol;   like TCP or UDP, zero means do not register
 */
#ifdef __STDC__
extern bool_t svc_register (SVCXPRT *, u_long, u_long,
			    void (*)(struct svc_req *, SVCXPRT *), int);
#else
extern bool_t svc_register ();
#endif

#ifndef _KERNEL
/*
 * Service un-registration
 *
 * svc_unregister(prog, vers)
 *	u_long prog;
 *	u_long vers;
 */
#ifdef __STDC__
extern void svc_unregister (u_long, u_long);
#else
extern void svc_unregister ();
#endif

/*
 * Memory based rpc for testing and timing.
 */
#ifdef __STDC__
extern SVCXPRT *svcraw_create (void);
#else
extern SVCXPRT *svcraw_create ();
#endif

/*
 * Udp based rpc. For compatibility reasons
 */
#ifdef __STDC__
extern SVCXPRT *svcudp_create (int);
extern SVCXPRT *svcudp_bufcreate (int, u_int, u_int);
#else
extern SVCXPRT *svcudp_create ();
extern SVCXPRT *svcudp_bufcreate ();
#endif

/*
 * Tcp based rpc.
 */
#ifdef __STDC__
extern SVCXPRT *svctcp_create (int, u_int, u_int);
extern SVCXPRT *svcfd_create (int, u_int, u_int);
#else
extern SVCXPRT *svctcp_create ();
extern SVCXPRT *svcfd_create ();
#endif
#endif	/* _KERNEL */

int __rpc_bindresvport(int fd, struct sockaddr_in *sin, int *portp, int qlen);
char *inet_ntoa_r(struct in_addr, char[]);
char *inet_ntoa(struct in_addr in);
int get_myaddress(struct sockaddr_in *addr);
int registerrpc(u_long prognum, u_long versnum, u_long procnum,
		char *(*progname)(char *), xdrproc_t inproc, xdrproc_t outproc);

#ifndef LINUX_TRANSITION_FINISHED
#define _rpc_dtablesize __rpc_dtbsize
#define xp_raddr xp_rtaddr.buf
#define UDPMSGSIZE 8800
#define UDPSMALLMSGSIZE 400
#endif

#ifdef __cplusplus
}
#endif

#endif /* !_RPC_SVC_SOC_H */
