static void 
dolog(struct port * port, int ctrl)
{
#ifdef not_yet
	struct sockaddr		sa;
	struct sockaddr_in	*sin = (struct sockaddr_in *)&sa;
	int			len = sizeof(sa);
	struct hostent		*hp;
	const char		*host;
	char			buf[BUFSIZ];
	int			connected = 1;
	static char             * curdom = NULL;

#ifdef INET6
	if (FAMILY(port) == AF_INET6)
		return;
#endif

        if (!curdom) {
	  char dbuf[MAXHOSTNAMELEN]; 
          if (getdomainname(dbuf, sizeof(dbuf)) >= 0) {
	    curdom = malloc(strlen(dbuf)+1);
	    if (curdom) 
	      strcpy(curdom, dbuf);
          }
        }

	if (getpeername(ctrl, &sa, &len) < 0) {
		if (errno != ENOTCONN) {
			logerr( "getpeername: %m");
			return;
		}
		if (recvfrom(ctrl, buf, sizeof(buf), MSG_PEEK, &sa, &len) < 0) {
			logerr( "recvfrom: %m");
			return;
		}
		connected = 0;
	}
	if (sa.sa_family != AF_INET) {
		logerr( "unexpected address family %u", sa.sa_family);
		return;
	}

	hp = gethostbyaddr((char *) &sin->sin_addr.s_addr,
				sizeof (sin->sin_addr.s_addr), AF_INET);

	host = hp ? hp->h_name : inet_ntoa(sin->sin_addr);

        if (strchr(host, '.') == 0)
	  return;

	if (curdom && port->rfc931) {
	        const char * dp;
		dp = host + strlen(host) - strlen(curdom);
		if (dp >= host && strcasecmp(dp, curdom) == 0)
		  return;
	}

	if (connected && port->rfc931)
		syslog(LOG_AUTH, "%s@%s wants %i",
				rfc931_name(sin, ctrl), host, ntohs(IN_PORT(port)));
	else
		syslog(LOG_AUTH, "%s wants %i",	host, ntohs(IN_PORT(port)));
#endif
}

#ifdef not_yet
/*
 * From tcp_log by
 *  Wietse Venema, Eindhoven University of Technology, The Netherlands.
 */

#include <setjmp.h>

#define	RFC931_PORT	113		/* Semi-well-known port */
/*
#define	TIMEOUT		4
#define	TIMEOUT2	10
 */
#define	TIMEOUT		10

static jmp_buf timebuf;

/* timeout - handle timeouts */

static void timeout(int sig) {
	longjmp(timebuf, sig);
}

/* rfc931_name - return remote user name */

static char *
rfc931_name(struct sockaddr_in * there, int ctrl)
{
	struct sockaddr_in here;	/* local link information */
	struct sockaddr_in sin;		/* for talking to RFC931 daemon */
	int		length;
	int		s;
	unsigned	remote;
	unsigned	local;
	static char	user[256];		/* XXX */
	char		buf[256];
	char		*cp;
	static char	*result = "USER_UNKNOWN";
	int		len;

	/* Find out local port number of our stdin. */

	length = sizeof(here);
	if (getsockname(ctrl, (struct sockaddr *) &here, &length) == -1) {
		logerr( "getsockname: %m");
		return (result);
	}
	/* Set up timer so we won't get stuck. */

	if ((s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		logerr( "socket: %m");
		return (result);
	}

	sin = here;
	sin.sin_port = htons(0);
	if (bind(s, (struct sockaddr *) &sin, sizeof(sin)) == -1) {
		logerr( "bind: %m");
		return (result);
	}

	signal(SIGALRM, timeout);
	if (setjmp(timebuf)) {
		close(s);			/* not: fclose(fp) */
		return (result);
	}
	alarm(TIMEOUT);

	/* Connect to the RFC931 daemon. */

	sin = *there;
	sin.sin_port = htons(RFC931_PORT);
	if (connect(s, (struct sockaddr *) &sin, sizeof(sin)) == -1) {
		close(s);
		alarm(0);
		return (result);
	}

	/* Query the RFC 931 server. Would 13-byte writes ever be broken up? */
	sprintf(buf, "%u,%u\r\n", ntohs(there->sin_port), ntohs(here.sin_port));


	for (len = 0, cp = buf; len < strlen(buf); ) {
		int	n;
		if ((n = write(s, cp, strlen(buf) - len)) == -1) {
			close(s);
			alarm(0);
			return (result);
		}
		cp += n;
		len += n;
	}

	/* Read response */
	for (cp = buf; cp < buf + sizeof(buf) - 1; ) {
		char	c;
		if (read(s, &c, 1) != 1) {
			close(s);
			alarm(0);
			return (result);
		}
		if (c == '\n')
			break;
		*cp++ = c;
	}
	*cp = '\0';

	if (sscanf(buf, "%u , %u : USERID :%*[^:]:%255s", &remote, &local, user) == 3
		&& ntohs(there->sin_port) == remote
		&& ntohs(here.sin_port) == local) {

		/* Strip trailing carriage return. */
		if ((cp = strchr(user, '\r')) != NULL)
			*cp = 0;
		result = user;
	}

	alarm(0);
	close(s);
	return (result);
}
#endif
