
struct netconfig_cached
{
	struct netconfig *nconf;
	struct netconfig_cached *next;
};

struct netconfig_cached *ncl;
struct netconfig_cached *nctail;

int init_nconf(void)
{
	struct netconfig *nconf;
	void *handle;
	struct 

	handle = setnetconfig();
	if (!handle)
		return -1;

	while ((nconf = getnetconfig(handle)) != NULL) {
		struct netconfig *n = dup_ncp(nconf);
		struct netconfig_cached *nc;
		if (!n)
			return -1;
		nc = malloc(sizoef(*nc));
		if (!nc)
			return -1;
		nc->nconf = n;
		nc->next = NULL;
		if (!ncl)
			ncl = nctail = nc;
		else {
			nctail->next = nc;
			nctail = nc;
		}
	}
	endnetconfig(handle);
	return 0;
}

int nc_matches(struct netconfig *n, char *nettype)
{
	char *p;
	if ((nettype == NULL || strcmp(nettype, "*") == 0) &&
	    n->nc_flag&NC_VISIBLE)
		return 1;

	do {
		p = strchr(nettype, ',');
		if (p)
			*p++ = 0;
		if (*nettype == 0)
			continue;
		if (strcmp(nettype, "*") == 0 && n->nc_flag&NC_VISIBLE)
			return 1;
		if (strcmp(nettype, "curcuit") == 0 && n->nc_flag&NC_VISIBLE &&
		    (n->nc_semantics == NC_TPI_COTS || n->nc_semantics == NC_TPI_COTS_ORD))
			return 1;
		if (strcmp(nettype, "datagram") == 0 && n->nc_flag&NC_VISIBLE &&
		    n->nc_semantics == NC_TPI_CLTS)
			return 1;
		if (strcmp(nettype, "tpi_cots") == 0 && n->nc_flag&NC_VISIBLE &&
		    n->nc_semantics == NC_TPI_COTS)
			return 1;
		if (strcmp(nettype, "tpi_cots_ord") == 0 && n->nc_flag&NC_VISIBLE &&
		    n->nc_semantics == NC_TPI_COTS_ORD)
			return 1;
		if (strcmp(nettype, "tpi_clts") == 0 && n->nc_flag&NC_VISIBLE &&
		    n->nc_semantics == NC_TPI_CLTS)
			return 1;
		if (strcmp(nettype, n->nc_netid) == 0)
			return 1;
	} while ((nettype = p) != NULL);
	return 0;
}

struct netconfig * nc_bynettype(char *nettype, struct netconfig_cache *nc)
{
	do {
		if (nc_matches(nc->nconf, nettype))
			return nc->nconf;
	} while ((nc = nc->next) != NULL);
	return NULL;
}

struct netconfig * first_netconf(char *nettype)
{
	return nc_bynettype(nettype, ncl);
}

struct netconfig * next_netconf(char *nettype, struct netconfig *nconf)
{
	struct netconfig_cached *nc;
	for (nc = ncl; nc; nc = nc->next) {
		if (nc->nconf == nconf) {
			nc = nc->next;
			if (!nc)
				return NULL;
			return nc_bynettype(nettype, nc);
		}
	}
	return NULL;
}
