%/*
% * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
% * unrestricted use provided that this legend is included on all tape
% * media and as a part of the software program in whole or part.  Users
% * may copy or modify Sun RPC without charge, but are not authorized
% * to license or distribute it to anyone else except as part of a product or
% * program developed by the user or with the express written consent of
% * Sun Microsystems, Inc.
% *
% * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
% * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
% * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
% *
% * Sun RPC is provided with no support and without any obligation on the
% * part of Sun Microsystems, Inc. to assist in its use, correction,
% * modification or enhancement.
% *
% * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
% * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
% * OR ANY PART THEREOF.
% *
% * In no event will Sun Microsystems, Inc. be liable for any lost revenue
% * or profits or other special, indirect and consequential damages, even if
% * Sun has been advised of the possibility of such damages.
% *
% * Sun Microsystems, Inc.
% * 2550 Garcia Avenue
% * Mountain View, California  94043
% */

/*
 *	autofs_prot.x
 *
 *	Copyright (c) 1993 Sun Microsystems Inc
 *	All Rights Reserved.
 */

%#pragma ident	"@(#)autofs_prot.x	1.2	94/05/03 SMI"

/*
 * Autofs protocol
 */

const A_MAXNAME	= 255;
const A_MAXOPTS	= 255;
const A_MAXPATH	= 1024;

struct mntrequest {
	string	name<A_MAXNAME>;	/* name to be looked up */
	string	map<A_MAXNAME>;		/* map to use */
	string  opts<A_MAXOPTS>;	/* default options */
	string  path<A_MAXPATH>;	/* mountpoint to use */
};


struct mntres {
	int status;	/* 0=OK, otherwise an errno from <sys/errno.h> */
};

struct umntrequest {
	int	isdirect;		/* direct mount */
	u_int	devid;			/* device id */
	struct umntrequest *next;	/* next unmount */
};

struct umntres {
	int status;
};

program AUTOFS_PROG {
	version AUTOFS_VERS {
		/*
		 * Do mount(s)
		 */
		mntres
		AUTOFS_MOUNT(mntrequest) = 1;

		/*
		 * Do unmount(s)
		 */
		umntres
		AUTOFS_UNMOUNT(umntrequest) = 2;
	} = 1;
} = 100099;
