#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <syslog.h>
#include <netinet/in.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/time.h>
#include <netdb.h>
#include <stddef.h>

#include "inetd.h"

static char *
proto2str(int proto) {
#if 0
  static char numstr[32];
#endif
  if (proto == IPPROTO_UDP)
    return "udp";
  else if (proto == IPPROTO_TCP)
    return "tcp";
  else
#if 0
 {
      struct protoent * prent;
      prent = getprotobynumber(proto);
      if (!prent) {
	sprintf(num, "%i", proto);
	return numstr;
      }
      return prent->p_name;
  }
#else
  return "???";
#endif
}

int
protostr2num(const char * proto) {
  struct protoent * prent;
  if (proto[0] >= '0' && proto[0] <= '9')
    return atoi(proto);
  prent = getprotobyname(proto);
  if (!prent)
    return 0;
  return prent->p_proto;
}

#if 0
char *
port2str(int port, int proto) {
  struct servent * sent;
  static char str[128];
  sent = getservbyport(htons(port), proto2str(proto));
  if (!sent)
    sprintf(str, "%i/%s", port, proto2str(proto));
  else
    sprintf(str, "%s/%s", sent->s_name, proto2str(proto));
  return str;
}
#endif

int
portstr2num(const char * serv, int proto) {
  struct servent * sent;
  if (serv[0] >= '0' && serv[0] <= '9' )
    return atoi(serv);
  sent = getservbyname(serv, proto2str(proto));
  if (!sent)
    return 0;
  return ntohs(sent->s_port);
}

int
socktypestr2num(const char * arg) {
  if (strcmp(arg, "stream") == 0)
    return SOCK_STREAM;
  else if (strcmp(arg, "dgram") == 0)
    return SOCK_DGRAM;
  else if (strcmp(arg, "rdm") == 0)
    return SOCK_RDM;
  else if (strcmp(arg, "seqpacket") == 0)
    return SOCK_SEQPACKET;
  else if (strcmp(arg, "raw") == 0)
    return SOCK_RAW;
  else {
    syslog(LOG_ERR, "unknown socktype \"%s\"", arg);
    return -1;
  }
}
