/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 *	Contains the mt libraries include definitions
 */

#pragma ident	"@(#)rpc_mt.h	1.7	94/04/27 SMI"

#ifdef linux /* vvv */
#define _MIT_POSIX_THREADS 1
#endif

#ifdef _REENTRANT

#if _MIT_POSIX_THREADS
#define	mutex_lock(m)			pthread_mutex_lock(m)
#define	mutex_trylock(m)		pthread_mutex_trylock(m)
#define	mutex_unlock(m)			pthread_mutex_unlock(m)
#define	mutex_init(m, n, p)		pthread_mutex_init(m, n, p)
#define	cond_signal(m)			pthread_cond_signal(m)
#define	cond_wait(c, m)			pthread_cond_wait(c, m)
#define	cond_init(m, n, p)		pthread_cond_init(m, n, p)
#define	rwlock_init(m, n, p)		_rwlock_init(m, n, p)
#define	rw_wrlock(x)			_rw_wrlock(x)
#define	rw_rdlock(x)			_rw_rdlock(x)
#define	rw_unlock(x)			_rw_unlock(x)
#define	thr_self()			pthread_self()
#define	thr_exit(x)			pthread_exit(x)
#define	thr_keycreate(m, n)		pthread_key_create(m, n)
#define	thr_setspecific(k, p)		pthread_setspecific(k, p)
#define	thr_getspecific(k, p)		pthread_getspecific(k, p)
#define	thr_sigsetmask(f, n, o)		_thr_sigsetmask(f, n, o)

#else

#define	mutex_lock(m)			_mutex_lock(m)
#define	mutex_trylock(m)		_mutex_trylock(m)
#define	mutex_unlock(m)			_mutex_unlock(m)
#define	mutex_init(m, n, p)		_mutex_init(m, n, p)
#define	cond_signal(m)			_cond_signal(m)
#define	cond_wait(c, m)			_cond_wait(c, m)
#define	cond_init(m, n, p)		_cond_init(m, n, p)
#define	rwlock_init(m, n, p)		_rwlock_init(m, n, p)
#define	rw_wrlock(x)			_rw_wrlock(x)
#define	rw_rdlock(x)			_rw_rdlock(x)
#define	rw_unlock(x)			_rw_unlock(x)
#define	thr_self()			_thr_self()
#define	thr_exit(x)			_thr_exit(x)
#define	thr_keycreate(m, n)		_thr_keycreate(m, n)
#define	thr_setspecific(k, p)		_thr_setspecific(k, p)
#define	thr_getspecific(k, p)		_thr_getspecific(k, p)
#define	thr_sigsetmask(f, n, o)		_thr_sigsetmask(f, n, o)

#endif /* !_MIT_POSIX_THREADS */

#else

#define _thr_main() (-1)
#define	rwlock_init(m, n, p)
#define	rw_wrlock(x)
#define	rw_rdlock(x)
#define	rw_unlock(x)
#define	_rwlock_init(m, n, p)
#define	_rw_wrlock(x)
#define	_rw_rdlock(x)
#define	_rw_unlock(x)
#define	mutex_lock(m)
#define	mutex_unlock(m)
#define	mutex_init(m, n, p)
#define	_mutex_lock(m)
#define	_mutex_unlock(m)
#define	_mutex_init(m, n, p)
#define	cond_signal(m)
#define	cond_wait(c, m)
#define	cond_init(m, n, p)
#define _cond_signal(m)
#define _cond_wait(m)
#define _cond_init(m, n, p)
#define	thr_self()
#define _thr_self()
#define	thr_exit(x)
#define _thr_exit(x)
#define	thr_keycreate(m, n)
#define _thr_keycreate(m, n) 0
#define	thr_setspecific(k, p)
#define _thr_setspecific(k, p) 0
#define	thr_getspecific(k, p)
#define _thr_getspecific(k, p) 0
#define	thr_sigsetmask(f, n, o)
#define _thr_sigsetmask(f, n, o)

#endif _REENTRANT

#define	MT_ASSERT_HELD(x)


#if _MIT_POSIX_THREADS
#include <pthread.h>
#define mutex_t		pthread_mutex_t
#define cond_t		pthread_cond_t
#define thread_key_t	pthread_key_t
#define rwlock_t	pthread_mutex_t /* probably incorrect (vvv) */
#define MUTEX_HELD(a)	1
#define RW_READ_HELD(a)	1
#define RW_WRITE_HELD(a)	1
#define DEFAULTMUTEX PTHREAD_MUTEX_INITIALIZER
#else
#include <thread.h>
#include <synch.h>
#endif


