/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * Copyright (c) 1986-1991 by Sun Microsystems Inc.
 */

#pragma ident	"@(#)rpc_td.c	1.8	94/04/24 SMI"

#if !defined(lint) && defined(SCCSIDS)
static char sccsid[] = "@(#)rpc_td.c 1.32 89/03/16 Copyr 1988 Sun Micro";
#endif

#include "rpc_mt.h"
#include <stdio.h>
#include <rpc/rpc.h>
#include <rpc/trace.h>
#include <errno.h>
#include <tiuser.h>
#include <string.h>
#ifndef linux
#include <stropts.h>
#endif
#include <netinet/tcp.h>
#include <syslog.h>

#define	MAXOPTSIZE 64

__td_setnodelay(int fd)
{
	int rval;
	static mutex_t td_opt_lock = DEFAULTMUTEX;
	static struct t_optmgmt t_optreq, t_optret;

	/* VARIABLES PROTECTED BY td_opt_lock: t_optreq, t_optret */

	trace2(TR__td_setnodelay, 0, fd);
	mutex_lock(&td_opt_lock);
	if (t_optreq.flags != T_NEGOTIATE) {
		int i = 1;
#ifndef linux
		struct opthdr *opt;
#else
		struct cmsghdr *opt;
#endif

		t_optreq.flags = T_NEGOTIATE;
		t_optreq.opt.maxlen = MAXOPTSIZE;
		t_optreq.opt.buf = (char *) malloc(MAXOPTSIZE);
#ifndef linux
		opt = (struct opthdr *)(t_optreq.opt.buf);
		opt->name = TCP_NODELAY;
		opt->len = 4;
		opt->level = IPPROTO_TCP;
		(void) memcpy((caddr_t) (t_optreq.opt.buf +
				sizeof (struct opthdr)), &i, sizeof (int));
		t_optreq.opt.len = sizeof (struct opthdr) + sizeof (int);
#else
		opt = (struct cmsghdr *)(t_optreq.opt.buf);
		opt->cmsg_type = TCP_NODELAY;
		opt->cmsg_len = sizeof(*opt) + sizeof(int);
		opt->cmsg_level = SOL_TCP;
		(void) memcpy(CMSG_DATA(opt), &i, sizeof (int));
		t_optreq.opt.len = opt->cmsg_len;
#endif

		t_optret.opt.maxlen = MAXOPTSIZE;
		t_optret.opt.len = 0;
		t_optret.opt.buf = (char *) malloc(MAXOPTSIZE);
	}

	rval = t_optmgmt(fd, &t_optreq, &t_optret);
	mutex_unlock(&td_opt_lock);
	trace2(TR__td_setnodelay, 1, fd);
	return (rval);
}
