/*
 *	rpc_trace.c
 *
 *	Copyright (c) 1988-1992 Sun Microsystems Inc
 *	All Rights Reserved.
 */

#pragma ident	"@(#)rpc_trace.c	1.10	94/04/24 SMI"

/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
#ifdef	TRACE
#include	"rpc_mt.h"
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/fcntl.h>
#include	<rpc/trace.h>
#include	<synch.h>

int rpc_trace_on = 1;

void
__rpc_trace(ev, d0, d1, d2, d3, d4, d5)
	u_long	ev, d0, d1, d2, d3, d4, d5;
{
	struct timeval	t;
	static struct trace_record	tr;
	static FILE	*fp = (FILE *) NULL;
	static time_t	last_time_written = (time_t) 0;
	extern mutex_t	libnsl_trace_lock;

	mutex_lock(&libnsl_trace_lock);
	if (! rpc_trace_on) {
		if (fp != (FILE *) NULL) {
			if (last_time_written != (time_t) 0) {
				last_time_written = (time_t) 0;
				fflush(fp);
			}
		}
		mutex_unlock(&libnsl_trace_lock);
		return;
	}

	if (fp == (FILE *) NULL) {
		fp = fopen("/tmp/rpc.trace", "w");
		if (fp == (FILE *) NULL) {
			mutex_unlock(&libnsl_trace_lock);
			return;
		}

		tr.tr_pid	= getpid();
	}

	gettimeofday(&t, NULL);
	tr.tr_time	= pack(t.tv_sec & 0xffff, (t.tv_usec >> 16) & 0xffff);
	tr.tr_tag	= ev;
	tr.tr_datum0	= d0;
	tr.tr_datum1	= d1;
	tr.tr_datum2	= d2;
	tr.tr_datum3	= d3;
	tr.tr_datum4	= d4;
	tr.tr_datum5	= d5;
	fwrite ((char *) &tr, sizeof (tr), 1, fp);
	if (last_time_written < t.tv_sec) {
		last_time_written = t.tv_sec;
		fflush(fp);
	}
	mutex_unlock(&libnsl_trace_lock);
}
#endif	/* TRACE */
