/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

#ident	"@(#)rpcdname.c	1.14	94/04/24 SMI"

/*
 * Copyright (c) 1986-1991 by Sun Microsystems Inc.
 */

#if !defined(lint) && defined(SCCSIDS)
static char sccsid[] = "@(#)rpcdname.c 1.2 89/03/10 Copyr 1989 Sun Micro";
#endif

/*
 * rpcdname.c
 * Gets the default domain name
 */
#include "rpc_mt.h"
#include <sys/types.h>
#include <sys/time.h>
#include <rpc/trace.h>
#include <rpc/rpc_com.h>
#include <string.h>

static char *default_domain = 0;

static char *
get_default_domain(void)
{
	char temp[256];
	extern mutex_t dname_lock;

/* VARIABLES PROTECTED BY dname_lock: default_domain */

	trace1(TR_get_default_domain, 0);
	mutex_lock(&dname_lock);
	if (default_domain) {
		mutex_unlock(&dname_lock);
		trace1(TR_get_default_domain, 1);
		return (default_domain);
	}
	if (getdomainname(temp, sizeof (temp)) < 0) {
		mutex_unlock(&dname_lock);
		trace1(TR_get_default_domain, 1);
		return (0);
	}
	if ((int) strlen(temp) > 0) {
		default_domain = strdup(temp);
	}
	mutex_unlock(&dname_lock);
	trace1(TR_get_default_domain, 1);
	return (default_domain);
}

/*
 * This is a wrapper for the system call getdomainname which returns a
 * ypclnt.h error code in the failure case.  It also checks to see that
 * the domain name is non-null, knowing that the null string is going to
 * get rejected elsewhere in the yp client package.
 */
int
__rpc_get_default_domain(domain)
	char **domain;
{
	trace1(TR___rpc_get_default_domain, 0);
	if ((*domain = get_default_domain()) != 0) {
		trace1(TR___rpc_get_default_domain, 1);
		return (0);
	}
	trace1(TR___rpc_get_default_domain, 1);
	return (-1);
}
