#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>

#include <tiuser.h>

#include "ti_int.h"

int t_look(int fd)
{
	int event;
	struct lt_desc *lt = __lt_lookup(fd);
	fd_set fds;
	fd_set fdex;
	int i;
	struct timeval tv;

	TRACE("t_look: fd=%d st=%d ev=%08x", lt->fd, lt->tstate, lt->tevent);

	event = lt->tevent;

	if (event)
		return event;

	if (lt->info.servtype == T_CLTS)
		return 0;

restart:
	FD_ZERO(&fds);
	FD_ZERO(&fdex);
	FD_SET(fd, &fds);
	FD_SET(fd, &fdex);
	memset(&tv, 0, sizeof(tv));
	i = select(fd+1, &fds, NULL, &fdex, &tv);
	if (i == 0)
		return 0;
	if (i < 0) {
		if (errno == EINTR)
			goto restart;
		return 0;
	}
	if (FD_ISSET(fd, &fds)) {
		if (lt->tstate == T_DATAXFER)
			event |= T_DATA;
		else if (lt->tstate == T_IDLE || lt->tstate == T_INCON)
			event |= T_LISTEN;
		else if (lt->tstate == T_OUTCON)
			event |= T_CONNECT;
	}
	if (FD_ISSET(fd, &fdex)) {
		if (lt->info.etsdu > 0)
			event |= T_EXDATA;
	}
	return (lt->tevent=event);
}
