#ifndef _TI_ACC_H_
#define _TI_ACC_H_

struct acc_elt
{
	struct acc_elt *next;
	struct acc_elt *prev;
	unsigned long  sequence;
	struct lt_desc *lt;
};

extern __inline__ struct acc_elt * lt_acc_lookup(struct lt_desc *lt,
						 unsigned long seq)
{
	struct acc_elt *acc;

	for (acc=lt->acc_q; acc; acc=acc->next) {
		if (acc->sequence == seq)
			return acc;
	}
	return NULL;
}

extern void __inline__ lt_acc_unlink(struct lt_desc *lt,
				     struct acc_elt *acc)
{
	if (acc->prev)
		acc->prev->next = acc->next;
	if (acc->next)
		acc->next->prev = acc->prev;
	if (acc == lt->acc_q)
		lt->acc_q = acc->next;
}

extern void __inline__ lt_acc_link(struct lt_desc *lt,
				   struct acc_elt *acc)
{
	acc->next = lt->acc_q;
	acc->prev = NULL;
	lt->acc_q = acc;
	if (acc->next)
		acc->next->prev = acc;
}


extern void __inline__ __lt_purge_acc_q(struct lt_desc *lt)
{
	struct acc_elt *acc, *next;

	for (acc=lt->acc_q; acc; acc=next) {
		next = acc->next;
		close(acc->lt->fd);
		free(acc);
	}
	lt->acc_q = NULL;
}

#endif
