#ifndef _TI_SOCK_H_
#define _TI_SOCK_H_ 1

struct sock_ops
{
	int family;
	int type;
	int protocol;
	int (*sockaddr2netbuf)(struct sockaddr_un*, int addr_size,
			       struct netbuf *);
	int (*netbuf2sockaddr)(struct sockaddr_un*, int *addr_size,
			       struct netbuf *);
	int (*makeoptions)(struct lt_desc *lt, struct netbuf *opt);
	int (*printaddr)(struct netbuf *addr);
};

int unix_autobind(struct lt_desc *lt, struct t_bind *bnd);
int unix_optmgmt(struct lt_desc *, struct t_optmgmt *req, struct t_optmgmt *ret);

int inet_autobind(struct lt_desc *lt, struct t_bind *bnd);
int inet_optmgmt(struct lt_desc *, struct t_optmgmt *req, struct t_optmgmt *ret);
int inet_laddr(struct lt_desc *, int);
int inet_rcvladdr(struct lt_desc *, struct netbuf*, struct netbuf*);
int inet_sndladdr(struct lt_desc *, struct netbuf*, struct netbuf*);

int inet6_autobind(struct lt_desc *lt, struct t_bind *bnd);
int inet6_optmgmt(struct lt_desc *, struct t_optmgmt *req, struct t_optmgmt *ret);
int inet6_laddr(struct lt_desc *, int);
int inet6_rcvladdr(struct lt_desc *, struct netbuf*, struct netbuf*);
int inet6_sndladdr(struct lt_desc *, struct netbuf*, struct netbuf*);

extern struct sock_ops tcp_sops;
extern struct sock_ops udp_sops;
extern struct sock_ops tcpv6_sops;
extern struct sock_ops udpv6_sops;
extern struct sock_ops unix_stream_sops;
extern struct sock_ops unix_dgram_sops;

#endif
