#ifndef KEYLIB_H_
#define KEYLIB_H_ 1

/* lib/librpc/key/xcrypt.c */

#ifndef SECURE_PUBLICKEY
int xencrypt(char *secret, char *passwd);
int xdecrypt(char *secret, char *passwd);
void xpasswd2des(char *pw, char *key, int sevenbit);
#else
int xxencrypt(char *secret, char *passwd, char *netname);
int xxdecrypt(char *secret, char *passwd, char *netname);
void xxpasswd2des(char *pw, char *netname, char *key, int sevenbit);
#endif

/* lib/librpc/key/publickey.c */
int getpublickey_long(netnamestr netname, keybuf_long *pkey);
int getsecretkey_long(netnamestr netname, keybuf_long *skey, char *passwd);

/* lib/librpc/rpc/key_call.c */

int key_call(u_long proc, xdrproc_t xdr_arg, char *arg,
	                  xdrproc_t xdr_rslt, char *rslt);
int key_setsecret(const char *secretkey);
int key_secretkey_is_set(void);
int key_encryptsession_pk(char *remotename, netobj *remotekey, des_block *deskey);
int key_decryptsession_pk(char *remotename, netobj *remotekey, des_block *deskey);
int key_encryptsession(const char *remotename, des_block *deskey);
int key_decryptsession(const char *remotename, des_block *deskey);
int key_gendes(des_block *key);
int key_setnet_long(struct key_netstarg_long *arg);
int key_get_conv_long(keybuf_long pkey, des_block *deskey);


#endif /* KEYLIB_H_ */
