/*
 *	Define and initialize MT client data
 */
#include <sys/types.h>
#include <sys/t_lock.h>

kmutex_t authdes_ops_lock;	/* auth_ops initialization in authdes_ops() */
kmutex_t authkerb_ops_lock;	/* auth_ops initialization in authkerb_ops() */
kmutex_t rcstat_lock;		/* rcstat structure updating */
kmutex_t xid_lock;		/* XID allocation */

static struct mutex_init_table {
	kmutex_t	*addr;
	void	*weight;
	char	*name;
	kmutex_type_t type;
};

static struct mutex_init_table rpcclnt_mutex_init_table[] = {
	&authdes_ops_lock,	DEFAULT_WT,	"auth_ops", 	MUTEX_DEFAULT,
	&authkerb_ops_lock,	DEFAULT_WT,	"auth_ops", 	MUTEX_DEFAULT,
	&rcstat_lock,		DEFAULT_WT,	"rcstat", 	MUTEX_DEFAULT,
	&xid_lock,		DEFAULT_WT,	"XID allocation", MUTEX_DEFAULT,
	(kmutex_t *) 0,		0,		(char *) 0,	MUTEX_DEFAULT
};

void
mt_rpcclnt_init()
{
	struct mutex_init_table	*mp;

	for (mp = rpcclnt_mutex_init_table; mp->addr != (kmutex_t *) 0; mp++)
		mutex_init(mp->addr, mp->name, mp->type, mp->weight);
}
