/*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)mt_svcinit.c	1.12	94/04/25 SMI"	/* SVr4.0 	*/

/*
 *	Define and initialize MT server data
 */
#include	<sys/types.h>
#include	<sys/t_lock.h>

/* protects the authdes cache (svcauthdes.c) */
kmutex_t	authdes_lock;
/* protects the authkerb cache (svcauthkerb.c) */
kmutex_t	authkerb_lock;
/* protects the dupreq variables (svc_clts.c) */
kmutex_t	dupreq_lock;
/* protects the request cred list (svc.c) */
kmutex_t	rqcred_lock;

/* protects the service request statistics structure (svc_clts.c) */
kmutex_t	rsstat_lock;
/* protects the svcauthdes_stats structure (svcauthdes.c) */
kmutex_t	svcauthdesstats_lock;
/* protects the svcauthkerb_stats structure (svcauthkerb.c) */
kmutex_t	svcauthkerbstats_lock;

/* protects the services list (svc.c) */
krwlock_t	svc_lock;
/* protects the transports list (svc.c) */
krwlock_t	xprt_lock;
/* protects the rpc list (svc.c) */
krwlock_t	rpc_list_lock;

static struct rwlock_init_table {
	krwlock_t	*addr;
	void		*weight;
	char		*name;
	krw_type_t	type;

};
static struct mutex_init_table {
	kmutex_t	*addr;
	void		*weight;
	char		*name;
	kmutex_type_t	type;
};

static struct rwlock_init_table rpcsvc_rwlock_init_table[] = {
	&svc_lock,	DEFAULT_WT,	"services list",	RW_DEFAULT,
	&xprt_lock,	DEFAULT_WT,	"transports list",	RW_DEFAULT,
	&rpc_list_lock,	DEFAULT_WT,	"rpc list",		RW_DEFAULT,
	(krwlock_t *)0,	0,		(char *)0,		RW_DEFAULT
};
static struct mutex_init_table rpcsvc_mutex_init_table[] = {
	&authdes_lock,	DEFAULT_WT,	"authdes cache",	MUTEX_DEFAULT,
	&authkerb_lock,	DEFAULT_WT,	"authkerb cache",	MUTEX_DEFAULT,
	&dupreq_lock,	DEFAULT_WT,	"dupreq",		MUTEX_DEFAULT,
	&rqcred_lock,	DEFAULT_WT,	"request cred list",	MUTEX_DEFAULT,
	&rsstat_lock,	DEFAULT_WT,	"service statistics",	MUTEX_DEFAULT,
	&svcauthdesstats_lock, DEFAULT_WT, "svcauthdes_stats", 	MUTEX_DEFAULT,
	&svcauthkerbstats_lock, DEFAULT_WT, "svcauthkerb_stats", MUTEX_DEFAULT,
	(kmutex_t *)0,	0,		(char *)0,		MUTEX_DEFAULT
};

void
mt_rpcsvc_init()
{
	struct mutex_init_table *mp;
	struct rwlock_init_table *rp;

	for (mp = rpcsvc_mutex_init_table; mp->addr != (kmutex_t *)0; mp++)
		mutex_init(mp->addr, mp->name, mp->type, mp->weight);

	for (rp = rpcsvc_rwlock_init_table; rp->addr != (krwlock_t *)0; rp++)
		rw_init(rp->addr, rp->name, rp->type, rp->weight);
}
